<script lang="ts">
import Vue from 'vue';
import { SEARCH_TYPE } from '../../common/constants';

export default Vue.extend({
  name: 'SlpSearchFilter',
  props: {
    initialFilter: {
      type: String,
      required: true,
    },
    searchCount: {
      type: Object,
      required: true,
    },
    isMobileOpen: {
      type: Boolean,
      required: true,
    },
  },
  data() {
    const filterOptions = [
      {
        value: SEARCH_TYPE.MARKETING,
        name: 'About GitLab',
        page: 'about.gitlab.com',
      },
      {
        value: SEARCH_TYPE.HANDBOOK,
        name: 'Handbook',
      },
      {
        value: SEARCH_TYPE.BLOG,
        name: 'Blog',
      },
    ];

    return {
      searchType: this.initialFilter,
      filterOptions,
    };
  },
  methods: {
    onSelectSearchType(searchType: string) {
      this.$emit('filterSelect', searchType);
    },
    onClose() {
      this.$emit('close');
    },
  },
});
</script>

<template>
  <div class="search-filter" :class="{ 'search-filter--mobile': isMobileOpen }">
    <div class="search-filter__close">
      <SlpButton variant="ghost" @click.native="onClose">
        <SlpTypography variant="body3" class="close-text">Close</SlpTypography>
        <SlpIcon icon="gl-close" />
      </SlpButton>
    </div>
    <div class="search-filter__header">
      <SlpTypography tag="h5" variant="body1-bold">{{
        isMobileOpen ? 'Filter' : 'Source'
      }}</SlpTypography>
    </div>
    <div class="slp-flex slp-flex-column">
      <div
        v-for="option in filterOptions"
        :key="option.value"
        class="search-filter__option"
      >
        <SlpRadio
          :for="option.name"
          :option="option.name"
          name="filterType"
          :checked="option.value === searchType"
          @input="
            onSelectSearchType(option.value);
            onClose();
          "
        />
        <span v-if="searchCount"
          >({{ searchCount[option.value].toLocaleString() }})</span
        >
        <SlpTypography
          v-if="option.page"
          tag="p"
          variant="body2"
          class="slp-color-text-200 slp-ml-32 slp-mt-8"
          >{{ option.page }}</SlpTypography
        >
      </div>
    </div>
    <div class="search-filter__footer">
      <SlpTypography tag="p" variant="body3" class="slp-mb-8">
        To search repositories and projects:
      </SlpTypography>
      <SlpButton
        href="https://gitlab.com/users/sign_in/"
        target="_blank"
        data-ga-location="search"
        data-ga-name="login source"
      >
        Login
      </SlpButton>
    </div>
  </div>
</template>

<style scoped lang="scss">
$border-color: 1px solid $color-surface-300;

.search-filter {
  display: none;
  border: $border-color;
  max-width: 255px;

  @media (min-width: $breakpoint-md) {
    display: block;
  }

  &--mobile {
    display: block;
    max-width: unset;
    position: fixed;
    top: 0;
    right: 0;
    bottom: 0;
    left: 0;
    background-color: white;
    padding: 0 $spacing-16;
    margin: 0 (-$spacing-16);
    overflow: hidden;
    z-index: $zindex-tooltip;
  }

  &__close {
    display: flex;
    justify-content: flex-end;
    padding: $spacing-8;
    color: $color-text-300;

    @media (min-width: $breakpoint-md) {
      display: none;
    }
  }

  &__header {
    padding: $spacing-16;
    border-bottom: $border-color;
    border-top: $border-color;

    @media (min-width: $breakpoint-md) {
      border-top: unset;
    }
  }

  &__option {
    padding: $spacing-16;
    border-bottom: $border-color;

    &:deep(.slp-radio) {
      margin-bottom: 0;
    }
  }

  &__footer {
    display: none;
    padding: $spacing-16;

    @media (min-width: $breakpoint-md) {
      display: block;
    }

    &:deep(.slp-btn) {
      background-color: white;
      width: 100%;
      justify-content: center;
      color: $color-primary-200;

      &:hover {
        background-color: $color-primary-200;
        color: white;
      }
    }
  }
}
</style>
